## alex 3.2.1

=== tests/Makefile ===
ALEX=../dist/build/alex/alex
HC=ghc
HC_OPTS=-Wall -fno-warn-missing-signatures -fno-warn-name-shadowing -fno-warn-unused-imports -fno-warn-tabs -Werror

.PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
HS_PROG_EXT = .exe
else
HS_PROG_EXT = .bin
endif

TESTS = \
        basic_typeclass.x \
        basic_typeclass_bytestring.x \
        default_typeclass.x \
        gscan_typeclass.x \
        monad_typeclass.x \
        monad_typeclass_bytestring.x \
        monadUserState_typeclass.x \
        monadUserState_typeclass_bytestring.x \
        null.x \
        posn_typeclass.x \
        posn_typeclass_bytestring.x \
        strict_typeclass.x \
        simple.x \
        tokens.x \
        tokens_bytestring.x \
        tokens_bytestring_unicode.x \
        tokens_gscan.x \
        tokens_monad_bytestring.x \
        tokens_monadUserState_bytestring.x \
        tokens_posn.x \
        tokens_posn_bytestring.x \
        tokens_scan_user.x \
        tokens_strict_bytestring.x \
        unicode.x

TEST_ALEX_OPTS = --template=..

%.n.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) $< -o $@

%.g.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) -g $< -o $@

CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.o *.bin *.exe

ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')

ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))

%.run : %$(HS_PROG_EXT)
	./$<

%$(HS_PROG_EXT) : %.hs
	$(HC) $(HC_OPTS) -package array -package bytestring $($*_LD_OPTS) $< -o $@

all :: $(ALL_TESTS)

.PHONY: clean
clean:
	rm -f $(CLEAN_FILES)

interact:
	ghci -cpp -i../src -i../dist/build/autogen -i../dist/build/alex/alex-tmp Main -fbreak-on-exception
# -args='--template=.. simple.x -o simple.n.hs'
# :set args --template=.. simple.x -o simple.n.hs

=== debian/changelog ===
alex (3.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Wed, 05 Jul 2017 21:09:42 -0400

alex (3.1.7-4) unstable; urgency=medium

  * Upload to unstable as part of GHC 8 transition.

 -- Clint Adams <clint@debian.org>  Thu, 27 Oct 2016 18:32:12 -0400

alex (3.1.7-3) experimental; urgency=medium

  * Drop build dependency on jade.  closes: #840587.

 -- Clint Adams <clint@debian.org>  Wed, 19 Oct 2016 13:01:25 -0400

alex (3.1.7-2) experimental; urgency=medium

  * Temporarily build-depend on ghc 8.

 -- Clint Adams <clint@debian.org>  Thu, 13 Oct 2016 14:01:29 -0400

## alex 3.2.3

=== tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ALEX=../dist/build/alex/alex
 HC=ghc
-HC_OPTS=-Wall -fno-warn-missing-signatures -fno-warn-name-shadowing -fno-warn-unused-imports -fno-warn-tabs -Werror
+HC_OPTS=-Wall -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin

=== debian/changelog ===
alex (3.2.3-1) unstable; urgency=medium

  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 16 Sep 2017 12:54:02 -0700

alex (3.2.2-1) unstable; urgency=medium

  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 03 Sep 2017 18:51:33 -0700

=== debian/control ===
Source: alex
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>,
           Clint Adams <clint@debian.org>,
           Louis Bettens <louis@bettens.info>,
           Dmitry Bogatov <KAction@gnu.org>
Priority: extra
Section: haskell
Build-Depends: alex <!stage1>,
               autoconf,
               cdbs (>= 0.4.59),
               debhelper (>= 9.20141010),
               docbook-utils,
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               ghc (>= 8),
               happy,
               haskell-devscripts (>= 0.13),
               libghc-quickcheck2-dev,
               xsltproc
Standards-Version: 3.9.8
Homepage: http://www.haskell.org/alex/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git

Package: alex
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: lexical analyser generator for Haskell
 Alex is a tool for generating lexical analysers in Haskell, given a
 description of the tokens to be recognised in the form of regular
 expressions. It is similar to the tool lex or flex for C/C++.

## alex 3.2.4

=== doc/Makefile ===
include config.mk

XML_DOC = alex
INSTALL_XML_DOC = alex

include docbook-xml.mk

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
-ALEX=../dist/build/alex/alex
+# NOTE: `cabal` will take care to build the local `alex` executable and place it into $PATH for us to pick up
+ALEX:=$(shell which alex)
+# NOTE: This assumes that a working `ghc` is on $PATH; this may not necessarily be the same GHC used by `cabal` for building `alex`.
 HC=ghc
 HC_OPTS=-Wall -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
 
@@ -36,7 +38,9 @@
         tokens_strict_bytestring.x \
         unicode.x
 
-TEST_ALEX_OPTS = --template=..
+# NOTE: `cabal` will set the `alex_datadir` env-var accordingly before invoking the test-suite
+#TEST_ALEX_OPTS = --template=../data/
+TEST_ALEX_OPTS=
 
 %.n.hs : %.x
 	$(ALEX) $(TEST_ALEX_OPTS) $< -o $@
@@ -62,6 +66,7 @@
 clean:
 	rm -f $(CLEAN_FILES)
 
+# NOTE: The `../dist` path belows don't aren't accurate anymore for recent cabals
 interact:
 	ghci -cpp -i../src -i../dist/build/autogen -i../dist/build/alex/alex-tmp Main -fbreak-on-exception
 # -args='--template=.. simple.x -o simple.n.hs'

=== debian/changelog ===
alex (3.2.4-4build3) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 10:55:45 +0000

alex (3.2.4-4build2) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 09:04:21 +0000

alex (3.2.4-4build1) eoan; urgency=medium

  * Rebuild against new GHC abi.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 17:40:12 +0200

alex (3.2.4-4) unstable; urgency=medium

  [ Clint Adams ]
  * Set Rules-Requires-Root to no.

  [ Ilias Tsitsimpis ]
  * Bump debhelper compat level to 10
  * debian/get_version.hs: Updated for Cabal 2.2

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 03 Oct 2018 14:48:22 +0300

alex (3.2.4-3) unstable; urgency=medium

  * Use Distribution.Version instead.

 -- Clint Adams <clint@debian.org>  Thu, 12 Apr 2018 14:40:32 -0400

alex (3.2.4-2) unstable; urgency=medium

  * Hide Distribution.Version's showVersion in our get_version util.

 -- Clint Adams <clint@debian.org>  Thu, 12 Apr 2018 10:32:23 -0400

alex (3.2.4-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Change Priority to optional. Since Debian Policy version 4.0.1,
    priority extra has been deprecated.
  * Use the HTTPS form of the copyright-format URL
  * Modify d/watch and Source field in d/copyright to use HTTPS
  * Declare compliance with Debian policy 4.1.1
  * Use salsa.debian.org URLs in Vcs-{Browser,Git} fields

  [ Clint Adams ]
  * Bump to Standards-Version 4.1.4.
  * New upstream release

 -- Clint Adams <clint@debian.org>  Mon, 09 Apr 2018 15:05:35 -0400

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
            Clint Adams <clint@debian.org>,
            Louis Bettens <louis@bettens.info>,
            Dmitry Bogatov <KAction@gnu.org>
-Priority: extra
+Priority: optional
 Section: haskell
+Rules-Requires-Root: no
 Build-Depends: alex <!stage1>,
                autoconf,
                cdbs (>= 0.4.59),
-               debhelper (>= 9.20141010),
+               debhelper (>= 10),
                docbook-utils,
                docbook-xml,
                docbook-xsl,
@@ -19,10 +20,10 @@
                haskell-devscripts (>= 0.13),
                libghc-quickcheck2-dev,
                xsltproc
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: http://www.haskell.org/alex/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-haskell/DHG_packages.git
+Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/alex
+Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/alex]
 
 Package: alex
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for alex
# This file is public domain software, originally written by Joey Hess.
# Adapted for alex by Ian Lynagh.
# Largely rewritten for cdbs and hlibrary.mk by Joachim Breitner in 2009.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_DEPENDENCIES = build-arch

DEB_ENABLE_TESTS = yes

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
DEB_SETUP_GHC_CONFIGURE_ARGS := --with-alex=/bin/true

cleanbuilddir/alex::
	cp -a dist/build/alex/alex-tmp/*.hs src/
endif

clean::
	[ ! -f doc/config.mk ] || $(MAKE) -C doc clean
	# Remove these so setup clean doesn't remove the generated files
	#rm -f src/Parser.y src/Scan.x

	rm -f debian/get_version.o debian/get_version.hi debian/get_version
	rm -f doc/alex.1
	# Hacks:
	rm -f doc/config.log doc/config.status doc/config.mk doc/configure


configure/alex::
	# doc/configure is not shipped, generate it
	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr

	# used in build to stick version into man page
	ghc --make debian/get_version.hs -o debian/get_version

build/alex:: build-ghc-stamp
	$(MAKE) -C doc html
	sed -e "s#@LIBDIR@#/usr/lib/alex-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/alex#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  doc/alex.1.in > doc/alex.1

install/alex:: debian/tmp-inst-ghc
	dh_installdirs usr/share/doc/alex/html
	cp -a doc/alex/* `pwd`/debian/`dh_listpackages`/usr/share/doc/alex/html

## alex 3.2.5

=== tests/Makefile ===
--- 
+++ 
@@ -1,8 +1,19 @@
-# NOTE: `cabal` will take care to build the local `alex` executable and place it into $PATH for us to pick up
-ALEX:=$(shell which alex)
+# NOTE: `cabal test` will take care to build the local `alex`
+# executable and place it into $PATH for us to pick up.  
+# 
+# If it doesn't look like the alex binary in $PATH comes from the
+# build tree, then we'll fall back to pointing to
+# ../dist/build/alex/alex to support running tests via "runghc
+# Setup.hs test".
+#
+ALEX=$(shell which alex)
+ifeq "$(filter $(dir $(shell pwd))%,$(ALEX))" ""
+ALEX=../dist/build/alex/alex
+endif
+
 # NOTE: This assumes that a working `ghc` is on $PATH; this may not necessarily be the same GHC used by `cabal` for building `alex`.
 HC=ghc
-HC_OPTS=-Wall -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
+HC_OPTS=-Wall -fwarn-incomplete-uni-patterns -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin

=== debian/changelog ===
alex (3.2.5-2build1.1) impish; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Sep 2021 06:54:16 +0200

alex (3.2.5-2build1) groovy; urgency=medium

  * No-change rebuild against libffi8ubuntu1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Aug 2020 00:02:14 +0000

alex (3.2.5-2) unstable; urgency=medium

  * Patch debian/get_version.hs for newer Cabal.

 -- Clint Adams <clint@debian.org>  Thu, 04 Jun 2020 08:13:41 -0400

alex (3.2.5-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Remove Dmitry Bogatov from Uploaders per his request. Thank you
    Dmitry for your previous maintainership.

  [ John Paul Adrian Glaubitz ]
  * Don't copy source code files for stage1 builds (Closes: #906434)

  [ Sean Whitton ]
  * New upstream release

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 26 May 2020 09:21:40 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: alex
-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>,
            Clint Adams <clint@debian.org>,
            Louis Bettens <louis@bettens.info>,
-           Dmitry Bogatov <KAction@gnu.org>
+           Ilias Tsitsimpis <iliastsi@debian.org>
 Priority: optional
 Section: haskell
 Rules-Requires-Root: no
@@ -20,7 +21,7 @@
                haskell-devscripts (>= 0.13),
                libghc-quickcheck2-dev,
                xsltproc
-Standards-Version: 4.1.4
+Standards-Version: 4.5.0
 Homepage: http://www.haskell.org/alex/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/alex
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/alex]

=== debian/rules ===
--- 
+++ 
@@ -16,9 +16,6 @@
 
 ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
 DEB_SETUP_GHC_CONFIGURE_ARGS := --with-alex=/bin/true
-
-cleanbuilddir/alex::
-	cp -a dist/build/alex/alex-tmp/*.hs src/
 endif
 
 clean::

## alex 3.2.7.1

=== examples/Makefile ===
ALEX=../dist/build/alex/alex
HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports -fno-warn-tabs

HAPPY=happy
HAPPY_OPTS=-agc

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
exeext=.exe
else
exeext=.bin
endif

PROGS = lit Tokens Tokens_gscan words words_posn words_monad tiny haskell tiger

ALEX_OPTS = --template=.. -g
# ALEX_OPTS = --template=..

%.alex.hs : %.x
	$(ALEX) $(ALEX_OPTS) $< -o $@

%.happy.hs : %.y
	$(HAPPY) $(HAPPY_OPTS) $< -o $@

%.o : %.hs
	$(HC) $(HC_OPTS) -c -o $@ $<

CLEAN_FILES += *.info *.hi *.o *.bin *.exe

all : $(addsuffix $(exeext),$(PROGS))

tiny$(exeext) : tiny.happy.hs Tokens_posn.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

lit$(exeext) : lit.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

Tokens$(exeext) : Tokens.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

Tokens_gscan$(exeext) : Tokens_gscan.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

words$(exeext) : words.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

words_posn$(exeext) : words_posn.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

words_monad$(exeext) : words_monad.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

haskell$(exeext) : haskell.alex.hs
	$(HC) $(HC_OPTS) -o $@ $^

tiger$(exeext) : tiger.alex.hs
	$(HC) $(HC_OPTS) -main-is TigerLexer -o $@ $^

.PHONY: clean
clean:
	rm -f *.o *.hi $(addsuffix $(exeext),$(PROGS)) \
		*.alex.hs *.happy.hs

=== debian/changelog ===
alex (3.2.7.1-3) unstable; urgency=medium

  * Set the path for the alex binary when running tests

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 12 Aug 2022 16:45:30 +0300

alex (3.2.7.1-2) unstable; urgency=medium

  * Declare compliance with Debian policy 4.6.1
  * Remove retired developer, Joachim Breitner, from Uploaders.
  * Build-depend on newer version of haskell-devscripts (Closes: #1011764)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 21 Jul 2022 09:23:05 +0300

alex (3.2.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Tue, 14 Jun 2022 13:00:06 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: alex
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
-Uploaders: Joachim Breitner <nomeata@debian.org>,
-           Clint Adams <clint@debian.org>,
-           Louis Bettens <louis@bettens.info>,
-           Ilias Tsitsimpis <iliastsi@debian.org>
+Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Clint Adams <clint@debian.org>,
+ Louis Bettens <louis@bettens.info>,
+ Ilias Tsitsimpis <iliastsi@debian.org>,
 Priority: optional
 Section: haskell
 Rules-Requires-Root: no
@@ -18,10 +17,10 @@
                dpkg-dev (>= 1.17.14),
                ghc (>= 8),
                happy,
-               haskell-devscripts (>= 0.13),
+               haskell-devscripts (>= 0.16.23),
                libghc-quickcheck2-dev,
                xsltproc
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: http://www.haskell.org/alex/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/alex
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/alex]

=== debian/rules ===
--- 
+++ 
@@ -46,3 +46,7 @@
 install/alex:: debian/tmp-inst-ghc
 	dh_installdirs usr/share/doc/alex/html
 	cp -a doc/alex/* `pwd`/debian/`dh_listpackages`/usr/share/doc/alex/html
+
+# Set the path for the alex binary, used by
+# tests/Makefile to run tests.
+check-ghc-stamp: export ALEX = ../dist-ghc/build/alex/alex

## alex 3.3.0.0

=== examples/Makefile ===
--- 
+++ 
@@ -12,8 +12,7 @@
 
 PROGS = lit Tokens Tokens_gscan words words_posn words_monad tiny haskell tiger
 
-ALEX_OPTS = --template=.. -g
-# ALEX_OPTS = --template=..
+ALEX_OPTS = --template=../data/ -g
 
 %.alex.hs : %.x
 	$(ALEX) $(ALEX_OPTS) $< -o $@

=== tests/Makefile ===
--- 
+++ 
@@ -1,19 +1,43 @@
 # NOTE: `cabal test` will take care to build the local `alex`
-# executable and place it into $PATH for us to pick up.  
-# 
+# executable and place it into $PATH for us to pick up.
+#
 # If it doesn't look like the alex binary in $PATH comes from the
 # build tree, then we'll fall back to pointing to
 # ../dist/build/alex/alex to support running tests via "runghc
 # Setup.hs test".
 #
+# If ALEX has been set outside, e.g. in the environment, we trust this setting.
+# This way, we can pass in the correct Alex executable from a CI environment
+# without danger of it being "fixed" by the logic below.
+# [2021-06-15, PR #189](https://github.com/simonmar/alex/pull/189)
+#
+ifndef ALEX
 ALEX=$(shell which alex)
 ifeq "$(filter $(dir $(shell pwd))%,$(ALEX))" ""
 ALEX=../dist/build/alex/alex
 endif
+endif
 
-# NOTE: This assumes that a working `ghc` is on $PATH; this may not necessarily be the same GHC used by `cabal` for building `alex`.
-HC=ghc
-HC_OPTS=-Wall -fwarn-incomplete-uni-patterns -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
+# NOTE: This assumes that a working `ghc` is on $PATH; this may not
+# necessarily be the same GHC used by `cabal` for building `alex`.
+#
+# Again, if HC has been set in the environment (e.g. by the CI), we keep this setting.
+# [2021-06-15, PR #189](https://github.com/simonmar/alex/pull/189)
+#
+HC ?= ghc
+
+# Some GHC warnings are only available from a certain version on
+# Get the GHC version
+GHC_VERSION:=$(shell $(HC) --numeric-version)
+GHC_VERSION_WORDS=$(subst ., ,$(GHC_VERSION))
+GHC_MAJOR_VERSION=$(word 1,$(GHC_VERSION_WORDS))
+GHC_MINOR_VERSION=$(word 2,$(GHC_VERSION_WORDS))
+# -fwarn-incomplete-uni-patterns only from 7.4
+WARNS_FOR_GHC_GTEQ_7_4=-fwarn-incomplete-uni-patterns
+WARNS_FOR_GHC_LT_7_4=-fno-warn-lazy-unlifted-bindings
+WARNS_DEP_GHC_GTEQ_7_4:=$(shell if [ $(GHC_MAJOR_VERSION) -gt 7 -o $(GHC_MAJOR_VERSION) -ge 7 -a $(GHC_MINOR_VERSION) -ge 4 ]; then echo "$(WARNS_FOR_GHC_GTEQ_7_4)"; else echo "$(WARNS_FOR_GHC_LT_7_4)"; fi)
+
+HC_OPTS=-Wall $(WARNS_DEP_GHC_GTEQ_7_4) -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
@@ -28,6 +52,10 @@
         basic_typeclass_bytestring.x \
         default_typeclass.x \
         gscan_typeclass.x \
+        issue_71.x \
+        issue_119.x \
+        issue_141.x \
+        issue_197.x \
         monad_typeclass.x \
         monad_typeclass_bytestring.x \
         monadUserState_typeclass.x \
@@ -73,7 +101,8 @@
 
 all :: $(ALL_TESTS)
 
-.PHONY: clean
+.PHONY: clean debug
+
 clean:
 	rm -f $(CLEAN_FILES)
 
@@ -82,3 +111,6 @@
 	ghci -cpp -i../src -i../dist/build/autogen -i../dist/build/alex/alex-tmp Main -fbreak-on-exception
 # -args='--template=.. simple.x -o simple.n.hs'
 # :set args --template=.. simple.x -o simple.n.hs
+
+debug :
+	@echo HC_OPTS=$(HC_OPTS)

=== debian/changelog ===
alex (3.3.0.0-1) unstable; urgency=medium

  * Declare compliance with Debian policy 4.6.2
  * New upstream release

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 02 Sep 2023 22:14:20 +0300

=== debian/control ===
--- 
+++ 
@@ -7,20 +7,15 @@
 Priority: optional
 Section: haskell
 Rules-Requires-Root: no
-Build-Depends: alex <!stage1>,
-               autoconf,
-               cdbs (>= 0.4.59),
-               debhelper (>= 10),
-               docbook-utils,
-               docbook-xml,
-               docbook-xsl,
-               dpkg-dev (>= 1.17.14),
-               ghc (>= 8),
-               happy,
-               haskell-devscripts (>= 0.16.23),
-               libghc-quickcheck2-dev,
-               xsltproc
-Standards-Version: 4.6.1
+Build-Depends:
+ alex <!stage1>,
+ cdbs (>= 0.4.59),
+ debhelper (>= 10),
+ haskell-devscripts (>= 0.16.23),
+ ghc (>= 9.4),
+ happy,
+ libghc-quickcheck2-dev,
+Standards-Version: 4.6.2
 Homepage: http://www.haskell.org/alex/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/alex
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/alex]

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for alex
# This file is public domain software, originally written by Joey Hess.
# Adapted for alex by Ian Lynagh.
# Largely rewritten for cdbs and hlibrary.mk by Joachim Breitner in 2009.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_DEPENDENCIES = build-arch

DEB_ENABLE_TESTS = yes

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
DEB_SETUP_GHC_CONFIGURE_ARGS := --with-alex=/bin/true
endif

clean::
	rm -f debian/alex.1

configure/alex::
	# used in build to stick version into man page
	ghc --make debian/get_version.hs -o debian/get_version

build/alex:: build-ghc-stamp
	sed -e "s#@LIBDIR@#/usr/lib/alex-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/alex#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  debian/alex.1.in > debian/alex.1

install/alex:: debian/tmp-inst-ghc

# Set the path for the alex binary, used by
# tests/Makefile to run tests.
check-ghc-stamp: export ALEX = ../dist-ghc/build/alex/alex

=== debian/watch ===
version=3
https://hackage.haskell.org/package/alex/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## alex 3.4.0.1

=== tests/Makefile ===
--- 
+++ 
@@ -32,12 +32,14 @@
 GHC_VERSION_WORDS=$(subst ., ,$(GHC_VERSION))
 GHC_MAJOR_VERSION=$(word 1,$(GHC_VERSION_WORDS))
 GHC_MINOR_VERSION=$(word 2,$(GHC_VERSION_WORDS))
-# -fwarn-incomplete-uni-patterns only from 7.4
-WARNS_FOR_GHC_GTEQ_7_4=-fwarn-incomplete-uni-patterns
-WARNS_FOR_GHC_LT_7_4=-fno-warn-lazy-unlifted-bindings
-WARNS_DEP_GHC_GTEQ_7_4:=$(shell if [ $(GHC_MAJOR_VERSION) -gt 7 -o $(GHC_MAJOR_VERSION) -ge 7 -a $(GHC_MINOR_VERSION) -ge 4 ]; then echo "$(WARNS_FOR_GHC_GTEQ_7_4)"; else echo "$(WARNS_FOR_GHC_LT_7_4)"; fi)
 
-HC_OPTS=-Wall $(WARNS_DEP_GHC_GTEQ_7_4) -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
+# Text dependency comes with GHC from 8.4 onwards
+GHC_SHIPS_WITH_TEXT:=$(shell if [ $(GHC_MAJOR_VERSION) -gt 8 -o $(GHC_MAJOR_VERSION) -ge 8 -a $(GHC_MINOR_VERSION) -ge 4 ]; then echo "yes"; else echo "no"; fi)
+
+# Turn off x-partial warning (new in GHC 9.8)
+WARNS_DEP_GHC_GTEQ_9_8:=$(shell if [ $(GHC_MAJOR_VERSION) -gt 9 -o $(GHC_MAJOR_VERSION) -ge 9 -a $(GHC_MINOR_VERSION) -ge 8 ]; then echo "-Wno-x-partial"; fi)
+
+HC_OPTS=-Wall $(WARNS_DEP_GHC_GTEQ_9_8) -fwarn-incomplete-uni-patterns -fno-warn-missing-signatures -fno-warn-unused-imports -fno-warn-tabs -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
@@ -77,6 +79,19 @@
         tokens_strict_bytestring.x \
         unicode.x
 
+ifeq "$(GHC_SHIPS_WITH_TEXT)" "yes"
+TEXT_DEP = -package text
+
+TEXT_TESTS = \
+		strict_text_typeclass.x \
+		posn_typeclass_strict_text.x \
+		tokens_monadUserState_strict_text.x
+else
+TEXT_DEP =
+
+TEXT_TESTS =
+endif
+
 # NOTE: `cabal` will set the `alex_datadir` env-var accordingly before invoking the test-suite
 #TEST_ALEX_OPTS = --template=../data/
 TEST_ALEX_OPTS=
@@ -89,7 +104,7 @@
 
 CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.o *.bin *.exe
 
-ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')
+ALL_TEST_HS = $(shell echo $(TESTS) $(TEXT_TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')
 
 ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))
 
@@ -97,7 +112,7 @@
 	./$<
 
 %$(HS_PROG_EXT) : %.hs
-	$(HC) $(HC_OPTS) -package array -package bytestring $($*_LD_OPTS) $< -o $@
+	$(HC) $(HC_OPTS) -package array -package bytestring $(TEXT_DEP) $($*_LD_OPTS) $< -o $@
 
 all :: $(ALL_TESTS)

=== debian/changelog ===
alex (3.4.0.1-1) unstable; urgency=medium

  [ Ilias Tsitsimpis ]
  * Declare compliance with Debian policy 4.7.0

  [ Clint Adams ]
  * New upstream release

 -- Clint Adams <clint@debian.org>  Thu, 19 Sep 2024 11:03:44 -0400

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  ghc (>= 9.4),
  happy,
  libghc-quickcheck2-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: http://www.haskell.org/alex/
 Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/alex
 Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/alex]

## alex 3.5.4.0

=== debian/changelog ===
alex (3.5.4.0-1) unstable; urgency=medium

  * Build using dh-haskell
  * New upstream release

 -- Scott Talbert <swt@techie.net>  Mon, 05 Jan 2026 18:15:25 -0500

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
 Rules-Requires-Root: no
 Build-Depends:
  alex <!stage1>,
- cdbs (>= 0.4.59),
- debhelper (>= 10),
+ dh-sequence-haskell,
+ debhelper-compat (= 13),
  haskell-devscripts (>= 0.16.23),
  ghc (>= 9.4),
  happy,

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for alex
# This file is public domain software, originally written by Joey Hess.
# Adapted for alex by Ian Lynagh.
# Largely rewritten for cdbs and hlibrary.mk by Joachim Breitner in 2009.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_DEPENDENCIES = build-arch

export DEB_ENABLE_TESTS = yes

ifneq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
export DEB_SETUP_GHC_CONFIGURE_ARGS := --with-alex=/bin/true
endif

execute_after_dh_auto_build-arch:
	# used in build to stick version into man page
	ghc --make debian/get_version.hs -o debian/get_version

	sed -e "s#@LIBDIR@#/usr/lib/alex-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/alex#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  debian/alex.1.in > debian/alex.1

# Set the path for the alex binary, used by
# tests/Makefile to run tests.
export ALEX = ../dist-ghc/build/alex/alex

%:
	dh $@
